%define STDC_VERSION 2.9.0
%define EGCS_VERSION 1.1.2
Summary: The GNU Compiler Collection.
Name: egcs-kernel
Version: %{EGCS_VERSION}
Release: 32tr
License: GPL
Group: Programming/Compilers
Source0: ftp://egcs.cygnus.com/pub/egcs/releases/egcs-%{EGCS_VERSION}/egcs-%{EGCS_VERSION}.tar.bz2
Patch0: ftp://ftp.varesearch.com/pub/support/hjl/egcs/egcs-1.1.2-linux.patch
Patch1: egcs-1.1.2-davem.patch
Patch2: egcs-1.1.2-gcse.patch
Patch3: egcs-1.1.2-cpu.patch
Patch4: egcs-1.1.2-integrate.patch
Patch5: egcs-1.1.2-expr.patch
Patch6: egcs-1.1.2-strlen.patch
Patch7: egcs-1.1.2-warn.patch
Patch8: egcs-1.1.2-addressof.patch
Patch9: egcs-1.1.2-fold.patch
Patch10: egcs-1.1.2-manpath.patch
Buildroot: /var/tmp/egcs-%{EGCS_VERSION}-root
Url: http://gcc.gnu.org/
Requires: binutils >= 2.9.1.0.21
Requires: glibc-devel
Prereq: /sbin/install-info

%description
The egcs package contains the GNU Compiler Collection: cc, gcc and
egcs. You'll need this package in order to compile C/C++ code.

%prep
%setup -q -n egcs-%{EGCS_VERSION}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1

%build
rm -rf obj-$RPM_ARCH-linux
mkdir obj-$RPM_ARCH-linux
cd obj-$RPM_ARCH-linux
CFLAGS="-mpentium -mcpu=pentium -march=pentium" ../configure  --prefix=/usr \
	--enable-shared --enable-threads \
	--enable-languages="C" --program-suffix="-kernel" \
	$RPM_ARCH-trustix-linux

PATH=$PATH:/sbin:/usr/sbin
# gperf is most likely broken on alpha and sparc 
touch  ../gcc/c-gperf.h
make MAKEINFO="makeinfo --no-split"  bootstrap-lean

%install
rm -rf $RPM_BUILD_ROOT
cd obj-$RPM_ARCH-linux
PATH=$PATH:/sbin:/usr/sbin
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man1
make install \
	prefix=$RPM_BUILD_ROOT/usr \
	mandir=$RPM_BUILD_ROOT/usr/share/man/man1 \
	MAKEINFO="makeinfo --no-split" 
FULLVER=$($RPM_BUILD_ROOT/usr/bin/gcc --version)
FULLPATH=$(dirname $RPM_BUILD_ROOT/usr/lib/gcc-lib/$RPM_ARCH-*/$FULLVER/cc1)

file $RPM_BUILD_ROOT/usr/bin/* | grep ELF | cut -d':' -f1 | xargs strip || :
strip $FULLPATH/{cc1,collect2}

# Quick and dirty.
mv $RPM_BUILD_ROOT/usr/man/man1/gcc.1 $RPM_BUILD_ROOT/usr/share/man/man1/egcs.1
gzip -9f $RPM_BUILD_ROOT/usr/share/man/man1/egcs.1

# fix some things
mv $RPM_BUILD_ROOT/usr/bin/$RPM_ARCH-trustix-linux-gcc $RPM_BUILD_ROOT/usr/bin/egcs-kernel
# Hack to support the kgcc hack
(cd $RPM_BUILD_ROOT/usr/bin/; ln -s egcs-kernel kgcc)

mkdir -p $RPM_BUILD_ROOT/lib

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc README* COPYING COPYING.LIB
%dir /usr/lib/gcc-lib
%dir /usr/lib/gcc-lib/%{_target_cpu}-trustix-linux
%dir /usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*
%dir /usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include
/usr/bin/egcs-kernel
/usr/bin/kgcc

/usr/share/man/man1/egcs.1*

/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/SYSCALLS.c.X
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/cc1
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/cpp
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/collect2
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/libgcc.a
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/libgcc.map
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/specs

%ifnarch alpha
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/*.o
%endif

/usr/%{_target_cpu}-trustix-linux

/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/README
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/float.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/iso646.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/limits.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/proto.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/stdarg.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/stdbool.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/stddef.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/syslimits.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/va-*.h
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/varargs.h
%ifarch ppc
/usr/lib/gcc-lib/%{_target_cpu}-trustix-linux/egcs-*/include/*-asm.h
%endif


%changelog
* Tue Jul 17 2001 Erlend Midttun <erlendbm@trustix.com>
- Inc serial number before release.

* Fri Nov 10 2000 Erlend Midttun <erlendbm@trustix.com>
- Added symlink to kgcc

* Fri Feb 18 2000 Erlend Midttun <erlendbm@trustix.com>
- Made it into a kernel only compiler

* Thu Feb 03 2000 Cristian Gafton <gafton@redhat.com>
- man pages are compressed

* Mon Jan 10 2000 Jim Kingdon <http://bugzilla.redhat.com/bugzilla>
- Add egcs-1.1.2-fold.patch from rth.  Update URL to http://gcc.gnu.org/.

* Fri Dec 3 1999 Jim Kingdon <http://developer.redhat.com>
- Replace egcs-1.1.2-fixtrunc.patch with egcs-1.1.2-integrate.patch
  (bugzilla #3777).  Add egcs-1.1.2-addressof.patch.  Depend on
  glibc-devel.

* Wed Sep 8 1999 Jim Kingdon <http://developer.redhat.com>
- Fix egcs-1.1.2-cpu.patch so that it works if more than one option
  from a set is specified.

* Thu Sep 3 1999 David S. Miller <davem@redhat.com>
- Fixup egcs-1.1.2-expr.patch to modify c-parse.in

* Wed Sep 1 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-strlen.patch (fixes compiler core dump on certain strlen
  invocations) and egcs-1.1.2-warn.patch (makes -Wpointer-arith work
  with glibc-2.1.2-7).

* Thu Aug 19 1999 Jim Kingdon <http://developer.redhat.com>
- Replace egcs-1.1.2-global.patch (which is bogus according to Richard
  Henderson) with egcs-1.1.2-fixtrunc.patch (which fixes the same bug,
  and looks more likely to be right).

* Thu Aug 12 1999 Cristian Gafton <gafton@redhat.com>
- build a dummy libstsdc++.so.2.9 library to maintain compatibility with
  other distribution not using HJ's Linux patches.

* Tue Jul 30 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-expr.patch to fix 3971 in bugzilla.

* Tue Jul 20 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-global.patch, fixes core dumps.

* Mon Jul 12 1999 Cristian Gafton <gafton@redhat.com>
- improved CPU handling patch

* Thu Jun 24 1999 Cristian Gafton <gafton@redhat.com>
- added patch from rth to stop cpp from defining __i486__ macros on -m486
  (it is not supposed to according to the info page, and this makes code
  compiled with -m486 not run on i386 anymore)

* Mon May 17 1999 Matt Wilson <msw@redhat.com>
- added patch from Dave Miller

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 12)

* Wed Mar 17 1999 Cristian Gafton <gafton@redhat.com>
- version 1.1.2
- added patch from davem

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- version 1.1.2pre3

